/* This Software Created by Muhammad Arshad Latti from Sargodha (Pakistan)
Web Page  http://www.geocities.com/arshadlati */

#include "Join File.h"

// external  variables
extern HINSTANCE g_hInstance;
extern HICON g_hIcon;

// global variables
HWND g_hwndJoin,g_hwndJoining;
BOOL g_bCancelJoin=FALSE;

// Join dialog box messages handler.
LRESULT CALLBACK DlgProcJoin(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		if (HIWORD(wParam) == BN_CLICKED)// On button click 
		{
			switch(LOWORD(wParam))
			{
				case IDC_BTN_ABOUT:// About button is clicked
				// show about dialog box
				DialogBox(g_hInstance, (LPCTSTR)IDD_ABOUT, hwndDlg, (DLGPROC)DlgProcAbout);
				break;
			case IDC_BTN_FILE:// Browse(for file) button is clicked
				{
				// get file name into text box
				GetFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_TXT_FILE));
				break;
			case IDC_BTN_FOLDER:// Browse(for folder) button is clicked
				// get folder path into text box
				GetFolderName(hwndDlg,GetDlgItem(hwndDlg,IDC_TXT_FOLDER));
				break;
			case IDC_BTN_JOIN:// Join button is clicked
				// check for text values in both 
				// text boxes (file path,folder path)
				//chk
				if (CheckEntry(hwndDlg,IDC_TXT_FILE,ERR_MSG_FILE)==FALSE)
					break;
				if (CheckEntry(hwndDlg,IDC_TXT_FOLDER,ERR_MSG_FOLDER)==FALSE)
					break;
				//~chk
				OnJoinButton();
				break;
				}

			}

		}
		break;
	case WM_INITDIALOG:
		g_hwndJoin=hwndDlg;
		// set icon
		SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		return TRUE;
	
	case WM_CLOSE:
		EndDialog(hwndDlg,0);
		break;


	}
	return FALSE;
}
// About dialog box messages handler
LRESULT CALLBACK DlgProcAbout(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam==IDC_BTN_CLOSE)// Close button clicked on about dialog box.
			EndDialog(hwndDlg,NULL);// close the about dialog box.
		break;
	case WM_INITDIALOG:
		{	
			// set icon
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
			return true;
		}
	case WM_CLOSE:
		{
			EndDialog(hwndDlg,NULL);
			break;
		}	
	}
	return FALSE;
}

// show joining dialog box and start operation 
void OnJoinButton(void)
{
DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_JOINING), g_hwndJoin, (DLGPROC)DlgProcJoining);
}

// joining dialog box messages handler
LRESULT CALLBACK DlgProcJoining(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		// if cancel button clicked then set cancel flag to TRUE
		if (HIWORD(wParam) == BN_CLICKED && LOWORD(wParam)==IDC_BTN_CANCEL)
			g_bCancelJoin=TRUE;
		break;
	case WM_INITDIALOG:
	g_hwndJoining=hwndDlg;

	// open join avi and play
	Animate_Open(GetDlgItem(hwndDlg,IDC_AVI_CONTROL),MAKEINTRESOURCE(AVI_JOIN));
	
	// start join operation by creating a new thread.
	DWORD dwThreadID;
	CreateThread(NULL, 0,
		(LPTHREAD_START_ROUTINE) JoinStart,
		NULL, 0, &dwThreadID);
		return true;
	}
	return FALSE;
}

// set flag and join file
void JoinStart(void)
{
	// set flag value to FALSE for continue join operation.
	g_bCancelJoin=FALSE;
	// try to join the file
	JoinFile();
	// close joining dialog box
	EndDialog(g_hwndJoining,NULL);
}

// combine files
void JoinFile(void)
{
	HANDLE hChunkFile,hOutFile;
	char strFileName[MAX_PATH],strFolderName[MAX_PATH],strBuffer[MAX_PATH]="";
	char  szInFilePath[MAX_PATH],szOutFileName[MAX_PATH];
    HWND hProBar=GetDlgItem(g_hwndJoining,IDC_PB_JOIN);// get the handle of progress bar

	// get text from both text boxes (file name/path , folder path)
	GetDlgItemText(g_hwndJoin,IDC_TXT_FILE,strFileName,MAX_PATH);
	GetDlgItemText(g_hwndJoin,IDC_TXT_FOLDER,strFolderName,MAX_PATH);
	
	lstrcpy(strBuffer,strFileName);

		// check if file name end with ".000".
		if((lstrlen(strFileName)  < 4) || (strFileName[lstrlen(strFileName)-1]!='0' && strFileName[lstrlen(strFileName) - 2] != '0' && strFileName[lstrlen(strFileName) - 3]!= '0' && strFileName[lstrlen(strFileName) - 4] != '.'))
			{
				ErrMsg(g_hwndJoining,ERR_MSG_OPENING);
				return;
			}
	strBuffer[lstrlen(strBuffer) - 4 ]='\0'; // terminate 4 character ( .000 ) from file name.(for example D:\hello.txt.000 to D:\hello.txt)
	lstrcpy(szInFilePath,strBuffer);

	// get the file name.(for example C:\movies\kings.mpg to kings.mpg)
	wsprintf(szOutFileName,"%s",PathFindFileName(strBuffer));
	
	lstrcpy(strBuffer,szOutFileName);
	PathCombine(szOutFileName,strFolderName,strBuffer);// combine path (for example d:\doc and data.doc to d:\doc\data.doc)

		//Try to create new file
		hOutFile= CreateFile(szOutFileName,
		GENERIC_WRITE,FILE_SHARE_READ,NULL,
		CREATE_NEW,FILE_ATTRIBUTE_NORMAL,
		NULL);

		if ( hOutFile ==INVALID_HANDLE_VALUE )
		{
				ErrMsg(g_hwndJoining,ERR_MSG_CREATING);
				return;
		}
//>>>>>>>>>>>>>>>>
		DWORD i,dwWritten,dwTotalSize;

		// get total output file size from input files
		dwTotalSize=GetTotalSize(szInFilePath);
		dwWritten=0;// variable used in progress bar

		for ( i = 0 ; i <  1000; i++ )// loop 0 to 999
		{
			if (g_bCancelJoin==TRUE)// check if someone cancel the join operation
				break;
			hChunkFile = OpenChunkFile(szInFilePath,i);// try to open chunk file 
			if ( hChunkFile ==INVALID_HANDLE_VALUE)
				break;
		// write chunk file data to output file
		dwWritten = WriteOutFile(hChunkFile,hOutFile,dwTotalSize,dwWritten,hProBar);
		CloseHandle(hChunkFile);// close chunk file
		}

//>>>>>>>>>>>>>>>>
		CloseHandle(hOutFile);// close output file
}

// get the total size of output file from input chunk files.
DWORD GetTotalSize(LPSTR szFilePath)
{
	char szFullPath[MAX_PATH + 10];
	DWORD i,dwFileSize=0;


		for ( i = 0 ; i <  1000; i++ )
			{
			if (g_bCancelJoin==TRUE)// check if someone cancel the join operation
				break;

			// append file extension for chunk files ( for example cat.bmp to cat.bmp.000) 
			if (i > 99)
			wsprintf(szFullPath,"%s.%lu",szFilePath,i);
			else if (i > 9)
				wsprintf(szFullPath,"%s.0%lu",szFilePath,i);
			else if ( i >= 0)
				wsprintf(szFullPath,"%s.00%lu",szFilePath,i);
			
			// check if file is exist 
			if ( PathFileExists(szFullPath) == FALSE)
				break;
			// get the chunk file size and add it to total.
			dwFileSize += GetFileSize(szFullPath);
			}
			return (dwFileSize);
}

// try to open chunk file 
HANDLE OpenChunkFile(LPSTR szFilePath,DWORD dwNumber)
{
	HANDLE hFile;
	char szFullPath[MAX_PATH + 10],szErr[MAX_PATH + 56];
	
	if ( dwNumber > 99)
		wsprintf(szFullPath,"%s.%lu",szFilePath,dwNumber);
	else if ( dwNumber > 9)
		wsprintf(szFullPath,"%s.0%lu",szFilePath,dwNumber);
	else if ( dwNumber >= 0)
		wsprintf(szFullPath,"%s.00%lu",szFilePath,dwNumber);

	if (PathFileExists(szFullPath) == FALSE)
				return (INVALID_HANDLE_VALUE);
		// try to open file.
	hFile = CreateFile(szFullPath,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);

			if ( hFile ==INVALID_HANDLE_VALUE )
		{
			wsprintf(szErr,"Error while opening chunk file.\n\" %s \"",szFullPath);
			ErrMsg(g_hwndJoining,szErr);
		}

	return (hFile);
}

// write chunk file to output file
DWORD WriteOutFile(HANDLE hChunkFile,HANDLE hfOut,DWORD dwTotalFileSize,DWORD PreWritten,HWND hwndPBar)
{
		BOOL bSuccess;
		DWORD dwRead,dwWrite,dwWritten;
		CHAR pBuffer[JOIN_BUFFER];

	dwWrite=0;
	dwWritten=PreWritten;

		do
	{
		// read file
		bSuccess=ReadFile(hChunkFile,pBuffer,JOIN_BUFFER,&dwRead,NULL);

	if (dwRead > 0)// if we get something from file
	{
	// write file
	WriteFile(hfOut,pBuffer,dwRead,&dwWrite,0);
	dwWritten += dwWrite;
	}

	// update progress bar
	SendMessage(hwndPBar,PBM_SETPOS,GetPercent(dwWritten,dwTotalFileSize),0);
	
	} while (dwRead > 0  && bSuccess && g_bCancelJoin == FALSE );

	return (dwWritten);


}
