#include "Split File.h"

// check text box text length if empty return FALSE.
BOOL IsEmpty(HWND hwnd)
{
	if ( GetWindowTextLength(hwnd) > 0 )
		return (TRUE);

	return (FALSE);
}

// mini version of message box for showing errors messages.
void ErrMsg(HWND hwnd,LPSTR lpstrError)
{
	MessageBox(hwnd,lpstrError,"Error",MB_ICONHAND | MB_OK);
}

// check a text box for text.
// text box is empty then show error message and return FALSE.
BOOL CheckEntry(HWND hwndOwnerDlg,int nId,LPSTR lpstrErrorMsg)
{
	HWND hwndEntry=GetDlgItem(hwndOwnerDlg,nId);
	if (IsEmpty(hwndEntry)==TRUE)
		return (TRUE);

	ErrMsg(hwndOwnerDlg,lpstrErrorMsg);
	return (FALSE);

}

// get a file size.
// note :: this function taken from "Copy File Part" Application.  
DWORD GetFileSize(LPSTR szFilePath)
{
	DWORD dwFileSize;
	HANDLE hCf;

	// try to open file.
	hCf = CreateFile(szFilePath,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);

	// check if file is opened.
	if (hCf==INVALID_HANDLE_VALUE)
		return (NULL);// file not open return null.

	dwFileSize=GetFileSize(hCf,NULL);// try to get file size.
	CloseHandle(hCf);// close file.
	
	// check for invalid file size.
	if (dwFileSize==INVALID_FILE_SIZE && GetLastError()!=NO_ERROR)
		return (NULL);// file size is invalid return null.
	
	return (dwFileSize);// return file size.
}
// get percentage in int(integer) from DWORD values.
// note :: this function taken from "Copy File Part" Application.  
int GetPercent(DWORD dwNewValue,DWORD dwMax)
{
	double dMax,dNewValue,dRet;
	int iRet;

	dMax=dwMax;
	dNewValue=dwNewValue;

	dRet =dNewValue / dMax;
	dRet *=100;

	iRet=dRet; // ???

	return(iRet);
}