/* This Software Created by Muhammad Arshad Latti from Sargodha (Pakistan)
Web Page  http://www.geocities.com/arshadlati */

#include "Split File.h"

// external  variables
extern HINSTANCE g_hInstance;
extern HICON g_hIcon;

// global variables 
HWND g_hwndSplitDlg,g_hwndSplittingDlg;// dialog boxes handle 
BOOL g_bCancelSplit=FALSE;// cancel flag

// split dialog box messages handler.
LRESULT CALLBACK DlgProcSplit(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		if (HIWORD(wParam) == BN_CLICKED)// On button click 
		{
			switch(LOWORD(wParam))
			{
			case IDC_BTN_ABOUT:// About button is clicked
				// show about dialog box
				DialogBox(g_hInstance, (LPCTSTR)IDD_ABOUT, hwndDlg, (DLGPROC)DlgProcAbout);
				break;
			case IDC_BTN_FILE:// Browse(for file) button is clicked
				// get file name into text box
				GetOpenFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_FILE));
				break;
			case IDC_BTN_FOLDER:// Browse(for folder) button is clicked
				// get folder path into text box
				GetFolderName(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_FOLDER));
				break;
			case IDC_BTN_SPLIT:// Split button is clicked
				// check for text values in three 
				// text boxes (file path,folder path,chunks size)
				//chk
				if (CheckEntry(hwndDlg,IDC_EB_FILE,ERR_MSG_FILE)==FALSE)
					break;
				if (CheckEntry(hwndDlg,IDC_EB_FOLDER,ERR_MSG_FOLDER)==FALSE)
					break;
				if (CheckEntry(hwndDlg,IDC_EB_SIZE,ERR_MSG_SIZE)==FALSE)
					break;
				//~chk
				OnSplitButton();
				break;
			}

		}
		break;
	case WM_INITDIALOG:
		g_hwndSplitDlg=hwndDlg;

		// set icon
		SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		// set KB is default option(radio button).
		CheckDlgButton(hwndDlg,IDC_OPT_KB,BST_CHECKED);
		return TRUE;
	
	case WM_CLOSE:
		EndDialog(hwndDlg,NULL);
		break;


	}
	return FALSE;
}

// show splitting dialog box and start operation 
void OnSplitButton(void)
{
DialogBox(g_hInstance, (LPCTSTR)IDD_SPLITTING, g_hwndSplitDlg, (DLGPROC)DlgProcSplitting);
}

// set flag and split file
void SplitStart(void)
{
	// set flag value to FALSE for continue split operation.
	g_bCancelSplit=FALSE;
	// try to split the file
	SplitFile();
	// close splitting dialog box
	EndDialog(g_hwndSplittingDlg,NULL);
}

// split a file
void SplitFile(void)
{
	HWND hwnd=g_hwndSplitDlg;
	HWND hwndDlg=g_hwndSplittingDlg;
	HWND hwndPB=GetDlgItem(hwndDlg,IDC_PB_SPLIT);// get the handle of progress bar
	HANDLE hfIn;
	char strFileName[MAX_PATH],strFolderName[MAX_PATH],strChunksSize[40];
	DWORD dwChunksSize,dwFileSize,dwChunks;

	// get text from three text boxes (file name/path , folder path , chunks size)
	GetDlgItemText(hwnd,IDC_EB_FILE,strFileName,MAX_PATH);
	GetDlgItemText(hwnd,IDC_EB_FOLDER,strFolderName,MAX_PATH);
	GetDlgItemText(hwnd,IDC_EB_SIZE,strChunksSize,40);
		
	// convert string to DWORD.
	dwChunksSize= strtoul(strChunksSize, NULL, 0);
	// get the file size
	dwFileSize=GetFileSize(strFileName);

	if (dwFileSize==0)
	{
			ErrMsg(hwndDlg,ERR_MSG_FILE);
			return;
	}

	if ( dwChunksSize < 1)
	{
			ErrMsg(hwndDlg,ERR_MSG_SIZE);
			return;
	}

	// if KB or MB option is selected then multiply in chunks size value.
	if (IsDlgButtonChecked(hwnd,IDC_OPT_KB)==BST_CHECKED)
			dwChunksSize *= 1024;//kb
		if (IsDlgButtonChecked(hwnd,IDC_OPT_MB)==BST_CHECKED)
			dwChunksSize *= 1048576;//mb

// if chunks size is greater then file size then show error message.
	if (dwChunksSize > dwFileSize )
	{
			ErrMsg(hwndDlg,ERR_MSG_SIZE);
			return;
	}

	dwChunks=dwFileSize / dwChunksSize;
	if ((dwChunks * dwChunksSize) < dwFileSize)
		dwChunks++;

	// if chunks are greater then 1000 then show error message.
	if (dwChunks > 1000)
	{
			ErrMsg(hwndDlg,ERR_MSG_SIZE);
			return;
	}

	// try to open file
	hfIn = CreateFile(strFileName,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);

	if (hfIn==INVALID_HANDLE_VALUE)// check if file opened.
	{
		ErrMsg(hwndDlg,ERR_MSG_OPENING);
		return;
	}

	//loop 
	DWORD i,dwWritten=0;
	HANDLE hOutFile;

		// loop for writing chunks
		for ( i = 0 ; i <  dwChunks; i++ )
		{
			// check if user cancel operation
			if (g_bCancelSplit==TRUE)
				break;
			// try to create new file for chunk.
			hOutFile = MakeNewFile(strFileName,strFolderName,i,hwndDlg);
			// check if file is created.
			if ( hOutFile ==INVALID_HANDLE_VALUE)
				break;
		// write chunk to file
		dwWritten = WriteChunk(hfIn,hOutFile,dwChunksSize,dwFileSize,dwWritten,hwndPB);
		// close chunk file
		CloseHandle(hOutFile);
		}
	//~loop

	// close file handle
	CloseHandle(hfIn);
}

// write chunk to file
DWORD WriteChunk(HANDLE hfIn,HANDLE hfOut,DWORD dwChunkSize,DWORD dwFileSize,DWORD PreWritten,HWND hwndPB)
{
	DWORD dwRemain,dwRead,dwWrite,dwWritten;
	CHAR pBuffer[SPLIT_BUFFER];
	BOOL bSuccess; 

	dwWrite=0;
	dwWritten=PreWritten;// used for progress bar
	dwRemain = dwChunkSize;

	do
	{
		if (dwRemain > SPLIT_BUFFER)
		{
		bSuccess=ReadFile(hfIn,pBuffer,SPLIT_BUFFER,&dwRead,NULL);
		}
		else
		{
		bSuccess=ReadFile(hfIn,pBuffer,dwRemain,&dwRead,NULL);
		}
	if (dwRead > 0)
	{
	WriteFile(hfOut,pBuffer,dwRead,&dwWrite,0);
	dwRemain-=dwWrite;
	dwWritten+=dwWrite;
	}

	// update progress bar
	SendMessage(hwndPB,PBM_SETPOS,GetPercent(dwWritten,dwFileSize),0);

	} while (dwRead > 0 && dwRemain > 0 && bSuccess && g_bCancelSplit==FALSE);

	return (dwWritten);
}

// try to create new chunk file
HANDLE MakeNewFile(LPSTR szFilePath,LPSTR szFolderPath,DWORD dwNo,HWND hwndOwner)
{
	HANDLE hfOut;
	char  strFileName[(MAX_PATH + MAX_PATH) + 2];
	char strErr[(MAX_PATH + MAX_PATH) + 56];
	char strBuffer[MAX_PATH];

	// get file name and append it to folder path
	wsprintf(strBuffer,"%s",PathFindFileName(szFilePath));
	PathCombine(strFileName,szFolderPath,strBuffer);

	// append number value(000-999) to chunk file path/name.
	if (dwNo > 99)
	wsprintf(strBuffer,".%lu",dwNo);
	else if(dwNo > 9)
		wsprintf(strBuffer,".0%lu",dwNo);
	else if (dwNo >=0)
		wsprintf(strBuffer,".00%lu",dwNo);

	lstrcat(strFileName,strBuffer);

	// try to create file
	hfOut= CreateFile(strFileName,
		GENERIC_WRITE,FILE_SHARE_READ,NULL,
		CREATE_NEW,FILE_ATTRIBUTE_NORMAL,
		NULL);
	// if error during creating file then show error message.
		if ( hfOut ==INVALID_HANDLE_VALUE )
		{
			wsprintf(strErr,"Fail to create new file\n\" %s \"",strFileName);
			ErrMsg(hwndOwner,strErr);
		}


	return (hfOut);
}

// spitting dialog box messages handler
LRESULT CALLBACK DlgProcSplitting(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		// if cancel button clicked then set cancel flag to TRUE
		if (HIWORD(wParam) == BN_CLICKED && LOWORD(wParam)==IDC_BTN_CANCEL)
			g_bCancelSplit=TRUE;
		break;
	case WM_INITDIALOG:
	g_hwndSplittingDlg=hwndDlg;

	// open split avi and play
	Animate_Open(GetDlgItem(hwndDlg,IDC_AVI_CONTROL),MAKEINTRESOURCE(AVI_SPLIT));
	
	// start split operation by creating a new thread.
	DWORD dwThreadID;
	CreateThread(NULL, 0,
		(LPTHREAD_START_ROUTINE) SplitStart,
		NULL, 0, &dwThreadID);
		return true;
	}
	return FALSE;
}
// About dialog box messages handler
LRESULT CALLBACK DlgProcAbout(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam==IDC_BTN_CLOSE)// Close button clicked on about dialog box.
			EndDialog(hwndDlg,NULL);// close the about dialog box.
		break;
	case WM_INITDIALOG:
		{	
			// set icon
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
			return true;
		}
	case WM_CLOSE:
		{
			EndDialog(hwndDlg,NULL);
			break;
		}	
	}
	return FALSE;
}

