#include <Windows.h> 
#include <shlobj.h> // Browse Folder.cpp > Browse for folder stuff
#include <shlwapi.h> // Path related function 
#include <commctrl.h> // common controls
#include "resource.h"


// DLL linkage 
#pragma comment( lib, "comctl32.lib" ) 
#pragma comment( lib, "shlwapi.lib" )  

// Common Functions
void ErrMsg(HWND hwnd,LPSTR lpstrError);
DWORD GetFileSize(LPSTR szFilePath);
int GetPercent(DWORD dwNewValue,DWORD dwMax);
void GetOpenFilePath(HWND hwnd,HWND hTextBox);
void GetFolderName(HWND hwndOwner,HWND hwndTextBox);
BOOL CheckEntry(HWND hwndOwnerDlg,int nId,LPSTR lpstrErrorMsg);

// Call back functions(used in Entry Point.cpp)
LRESULT CALLBACK DlgProcSplit(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// Used in only Split File.cpp
#define SPLIT_BUFFER 4096

#define ERR_MSG_SIZE "Please enter valid split size value in bytes."
#define ERR_MSG_FILE "Please choose a valid file path."
#define ERR_MSG_FOLDER "Please choose a valid output folder path."
#define ERR_MSG_OPENING "Error while opening input file."

void OnSplitButton(void);
void SplitStart(void);
void SplitFile(void);
DWORD WriteChunk(HANDLE hfIn,HANDLE hfOut,DWORD dwChunkSize,DWORD dwFileSize,DWORD PreWritten,HWND hwndPB);
HANDLE MakeNewFile(LPSTR szFilePath,LPSTR szFolderPath,DWORD dwNo,HWND hwndOwner);

LRESULT CALLBACK DlgProcSplitting(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProcAbout(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// Used in only Common Functions.cpp
BOOL IsEmpty(HWND hwnd);

// Optional :: link dynamic (dll) C/C++ run time library
//#pragma comment(linker, "/nodefaultlib:libc.lib")//Disable C run-time library static linkage.
//#pragma comment(linker, "/defaultlib:MSVCRT.LIB")//Link dynamic C run-time library {msvcrt.dll). 
//#pragma comment(linker, "/OPT:NOWIN98")//Disable fast load future for Window 98